﻿!mod$ v1 sum:b20f32cf411c562b
module w90_boltzwann
use w90_parameters,only:boltz_mu_min
use w90_parameters,only:boltz_mu_max
use w90_parameters,only:boltz_mu_step
use w90_parameters,only:boltz_temp_min
use w90_parameters,only:boltz_temp_max
use w90_parameters,only:boltz_temp_step
use w90_parameters,only:boltz_kmesh_spacing
use w90_parameters,only:boltz_kmesh
use w90_parameters,only:boltz_tdf_energy_step
use w90_parameters,only:boltz_relax_time
use w90_parameters,only:boltz_bandshift
use w90_parameters,only:boltz_bandshift_firstband
use w90_parameters,only:boltz_bandshift_energyshift
use w90_parameters,only:timing_level
use w90_parameters,only:dis_win_min
use w90_parameters,only:dis_win_max
use w90_parameters,only:spin_decomp
use w90_parameters,only:boltz_dos_adpt_smr
use w90_parameters,only:boltz_dos_adpt_smr_fac
use w90_parameters,only:boltz_dos_smr_fixed_en_width
use w90_parameters,only:boltz_2d_dir_num
use w90_parameters,only:boltz_tdf_smr_fixed_en_width
use w90_parameters,only:cell_volume
use w90_parameters,only:num_elec_per_state
use w90_parameters,only:iprint
use w90_io,only:io_error
use w90_io,only:stdout
use w90_io,only:io_stopwatch
use w90_io,only:io_file_unit
use w90_io,only:seedname
use w90_utility,only:utility_inv3
use w90_utility,only:utility_inv2
use w90_dos,only:dos_get_k
use w90_dos,only:dos_get_levelspacing
use w90_constants,only:i64
use w90_constants,only:dp
use w90_constants,only:pi
use w90_constants,only:twopi
use w90_constants,only:cmplx_i
use w90_constants,only:cmplx_0
use w90_constants,only:cmplx_1
use w90_constants,only:eps2
use w90_constants,only:eps5
use w90_constants,only:eps6
use w90_constants,only:eps7
use w90_constants,only:eps8
use w90_constants,only:eps10
use w90_constants,only:smearing_cutoff
use w90_constants,only:min_smearing_binwidth_ratio
use w90_constants,only:elem_charge_si
use w90_constants,only:elec_mass_si
use w90_constants,only:hbar_si
use w90_constants,only:k_b_si
use w90_constants,only:bohr_magn_si
use w90_constants,only:eps0_si
use w90_constants,only:speedlight_si
use w90_constants,only:ev_au
use w90_constants,only:ev_seconds
use w90_constants,only:bohr_angstrom_internal
use w90_constants,only:constants_version_str1
use w90_constants,only:constants_version_str2
use w90_constants,only:bohr
use w90_constants,only:bohr_version_str
use w90_postw90_common,only:irvec
use w90_postw90_common,only:crvec
use w90_postw90_common,only:ndegen
use w90_postw90_common,only:nrpts
use w90_postw90_common,only:rpt_origin
use w90_postw90_common,only:num_int_kpts_on_node
use w90_postw90_common,only:int_kpts
use w90_postw90_common,only:weight
use w90_postw90_common,only:v_matrix
use w90_postw90_common,only:pw90common_kmesh_spacing
use w90_postw90_common,only:pw90common_wanint_setup
use w90_postw90_common,only:pw90common_wanint_get_kpoint_file
use w90_postw90_common,only:pw90common_wanint_param_dist
use w90_postw90_common,only:pw90common_wanint_data_dist
use w90_postw90_common,only:pw90common_get_occ
use w90_postw90_common,only:pw90common_fourier_r_to_k
use w90_postw90_common,only:pw90common_fourier_r_to_k_new
use w90_postw90_common,only:pw90common_fourier_r_to_k_new_second_d
use w90_postw90_common,only:pw90common_fourier_r_to_k_new_second_d_tb_conv
use w90_postw90_common,only:pw90common_fourier_r_to_k_vec
use w90_postw90_common,only:pw90common_fourier_r_to_k_vec_dadb
use w90_postw90_common,only:pw90common_fourier_r_to_k_vec_dadb_tb_conv
use w90_comms,only:on_root
use w90_comms,only:num_nodes
use w90_comms,only:my_node_id
use w90_comms,only:root_id
use w90_comms,only:comms_bcast
use w90_comms,only:comms_send
use w90_comms,only:comms_recv
use w90_comms,only:comms_reduce
use w90_comms,only:comms_allreduce
use w90_comms,only:comms_gatherv
use w90_comms,only:comms_scatterv
use w90_comms,only:comms_setup
use w90_comms,only:comms_setup_vars
use w90_comms,only:comms_array_split
use w90_comms,only:comms_end
use w90_comms,only:comms_barrier
use w90_comms,only:w90_comms$w90_comms$comms_reduce_int=>comms_reduce_int
use w90_comms,only:w90_comms$w90_comms$comms_reduce_real=>comms_reduce_real
use w90_comms,only:w90_comms$w90_comms$comms_allreduce_real=>comms_allreduce_real
use w90_comms,only:w90_comms$w90_comms$comms_gatherv_real_2_3=>comms_gatherv_real_2_3
private::boltz_mu_min
private::boltz_mu_max
private::boltz_mu_step
private::boltz_temp_min
private::boltz_temp_max
private::boltz_temp_step
private::boltz_kmesh_spacing
private::boltz_kmesh
private::boltz_tdf_energy_step
private::boltz_relax_time
private::boltz_bandshift
private::boltz_bandshift_firstband
private::boltz_bandshift_energyshift
private::timing_level
private::dis_win_min
private::dis_win_max
private::spin_decomp
private::boltz_dos_adpt_smr
private::boltz_dos_adpt_smr_fac
private::boltz_dos_smr_fixed_en_width
private::boltz_2d_dir_num
private::boltz_tdf_smr_fixed_en_width
private::cell_volume
private::num_elec_per_state
private::iprint
private::io_error
private::stdout
private::io_stopwatch
private::io_file_unit
private::seedname
private::utility_inv3
private::utility_inv2
private::dos_get_k
private::dos_get_levelspacing
private::i64
private::dp
private::pi
private::twopi
private::cmplx_i
private::cmplx_0
private::cmplx_1
private::eps2
private::eps5
private::eps6
private::eps7
private::eps8
private::eps10
private::smearing_cutoff
private::min_smearing_binwidth_ratio
private::elem_charge_si
private::elec_mass_si
private::hbar_si
private::k_b_si
private::bohr_magn_si
private::eps0_si
private::speedlight_si
private::ev_au
private::ev_seconds
private::bohr_angstrom_internal
private::constants_version_str1
private::constants_version_str2
private::bohr
private::bohr_version_str
private::irvec
private::crvec
private::ndegen
private::nrpts
private::rpt_origin
private::num_int_kpts_on_node
private::int_kpts
private::weight
private::v_matrix
private::pw90common_kmesh_spacing
private::pw90common_wanint_setup
private::pw90common_wanint_get_kpoint_file
private::pw90common_wanint_param_dist
private::pw90common_wanint_data_dist
private::pw90common_get_occ
private::pw90common_fourier_r_to_k
private::pw90common_fourier_r_to_k_new
private::pw90common_fourier_r_to_k_new_second_d
private::pw90common_fourier_r_to_k_new_second_d_tb_conv
private::pw90common_fourier_r_to_k_vec
private::pw90common_fourier_r_to_k_vec_dadb
private::pw90common_fourier_r_to_k_vec_dadb_tb_conv
private::on_root
private::num_nodes
private::my_node_id
private::root_id
private::comms_bcast
private::comms_send
private::comms_recv
private::comms_reduce
private::comms_allreduce
private::comms_gatherv
private::comms_scatterv
private::comms_setup
private::comms_setup_vars
private::comms_array_split
private::comms_end
private::comms_barrier
private::w90_comms$w90_comms$comms_reduce_int
private::w90_comms$w90_comms$comms_reduce_real
private::w90_comms$w90_comms$comms_allreduce_real
private::w90_comms$w90_comms$comms_gatherv_real_2_3
integer(4),parameter,private::xx=1_4
integer(4),parameter,private::xy=2_4
integer(4),parameter,private::yy=3_4
integer(4),parameter,private::xz=4_4
integer(4),parameter,private::yz=5_4
integer(4),parameter,private::zz=6_4
character(74_4,1),parameter,private::pub_string_1="Please cite the following paper when publishing results obtained using    "
character(74_4,1),parameter,private::pub_string_2="the BoltzWann module:                                                     "
character(74_4,1),parameter,private::pub_string_3="G. Pizzi, D. Volja, B. Kozinsky, M. Fornari, and N. Marzari,              "
character(74_4,1),parameter,private::pub_string_4="Comp. Phys. Comm. 185, 422 (2014); DOI:10.1016/j.cpc.2013.09.015          "
private::calctdfanddos
private::minusfermiderivative
private::tdf_kpt
contains
subroutine boltzwann_main()
end
subroutine calctdfanddos(tdf,tdfenergyarray)
real(8),intent(out)::tdf(:,:,:)
real(8),intent(in)::tdfenergyarray(:)
end
function minusfermiderivative(e,mu,kt)
real(8),intent(in)::e
real(8),intent(in)::mu
real(8),intent(in)::kt
real(8)::minusfermiderivative
end
subroutine tdf_kpt(kpt,energyarray,eig_k,deleig_k,tdf_k)
real(8),intent(in)::kpt(1_8:3_8)
real(8),intent(in)::energyarray(:)
real(8),intent(in)::eig_k(:)
real(8),intent(in)::deleig_k(:,:)
real(8),intent(out)::tdf_k(:,:,:)
end
end
