﻿!mod$ v1 sum:126669074796caab
module w90_gyrotropic
use w90_constants,only:dp
use w90_berry,only:berry_get_imf_klist
use w90_berry,only:berry_get_imfgh_klist
private::dp
private::berry_get_imf_klist
private::berry_get_imfgh_klist
integer(4),parameter,private::alpha_a(1_8:3_8)=[INTEGER(4)::2_4,3_4,1_4]
integer(4),parameter,private::beta_a(1_8:3_8)=[INTEGER(4)::3_4,1_4,2_4]
integer(4),parameter,private::alpha_s(1_8:6_8)=[INTEGER(4)::1_4,2_4,3_4,1_4,1_4,2_4]
integer(4),parameter,private::beta_s(1_8:6_8)=[INTEGER(4)::1_4,2_4,3_4,2_4,3_4,3_4]
private::gyrotropic_get_k_list
private::gyrotropic_get_curv_w_k
private::gyrotropic_get_noa_k
private::gyrotropic_get_noa_bnl_orb
private::gyrotropic_get_noa_bnl_spin
private::gyrotropic_outprint_tensor
private::gyrotropic_outprint_tensor_w
contains
subroutine gyrotropic_main()
end
subroutine gyrotropic_get_k_list(kpt,kweight,gyro_k_spn,gyro_k_orb,gyro_d,gyro_dw,gyro_c,gyro_dos,gyro_noa_orb,gyro_noa_spn,eval_k,eval_d,eval_dw,eval_noa,eval_spn,eval_c,eval_dos)
real(8),intent(in)::kpt(1_8:3_8)
real(8),intent(in)::kweight
real(8),intent(inout)::gyro_k_spn(:,:,:)
real(8),intent(inout)::gyro_k_orb(:,:,:)
real(8),intent(inout)::gyro_d(:,:,:)
real(8),intent(inout)::gyro_dw(:,:,:,:)
real(8),intent(inout)::gyro_c(:,:,:)
real(8),intent(inout)::gyro_dos(:)
real(8),intent(inout)::gyro_noa_orb(:,:,:,:)
real(8),intent(inout)::gyro_noa_spn(:,:,:,:)
logical(4),intent(in)::eval_k
logical(4),intent(in)::eval_d
logical(4),intent(in)::eval_dw
logical(4),intent(in)::eval_noa
logical(4),intent(in)::eval_spn
logical(4),intent(in)::eval_c
logical(4),intent(in)::eval_dos
end
subroutine gyrotropic_get_curv_w_k(eig,aa,curv_w_k)
real(8),intent(in)::eig(:)
complex(8),intent(in)::aa(:,:,:)
real(8),intent(out)::curv_w_k(:,:,:)
end
subroutine gyrotropic_get_noa_k(kpt,kweight,eig,del_eig,aa,uu,gyro_noa_orb,gyro_noa_spn)
real(8),intent(in)::kpt(1_8:3_8)
real(8),intent(in)::kweight
real(8),intent(in)::eig(:)
real(8),intent(in)::del_eig(:,:)
complex(8),intent(in)::aa(:,:,:)
complex(8),intent(in)::uu(:,:)
real(8),intent(inout)::gyro_noa_orb(:,:,:,:)
real(8),intent(inout),optional::gyro_noa_spn(:,:,:,:)
end
subroutine gyrotropic_get_noa_bnl_orb(eig,del_eig,aa,num_occ,occ_list,num_unocc,unocc_list,bnl)
real(8),intent(in)::eig(:)
real(8),intent(in)::del_eig(:,:)
complex(8),intent(in)::aa(:,:,:)
integer(4),intent(in)::num_occ
integer(4),intent(in)::occ_list(:)
integer(4),intent(in)::num_unocc
integer(4),intent(in)::unocc_list(:)
complex(8),intent(out)::bnl(:,:,:,:)
end
subroutine gyrotropic_get_noa_bnl_spin(s_h,num_occ,occ_list,num_unocc,unocc_list,bnl)
complex(8),intent(in)::s_h(:,:,:)
integer(4),intent(in)::num_occ
integer(4),intent(in)::occ_list(:)
integer(4),intent(in)::num_unocc
integer(4),intent(in)::unocc_list(:)
complex(8),intent(out)::bnl(:,:,:,:)
end
subroutine gyrotropic_outprint_tensor(f_out_name,arref,arref1d,arrefw,units,comment,symmetrize)
character(30_4,1),intent(in)::f_out_name
real(8),intent(in),optional::arref(:,:,:)
real(8),intent(in),optional::arref1d(:)
real(8),intent(in),optional::arrefw(:,:,:,:)
character(30_4,1),intent(in),optional::units
character(120_4,1),intent(in),optional::comment
logical(4),intent(in),optional::symmetrize
end
subroutine gyrotropic_outprint_tensor_w(file_unit,omega,arr33n,arrn,symmetrize)
integer(4),intent(in)::file_unit
real(8),intent(in)::omega
real(8),intent(in),optional::arr33n(:,:,:)
real(8),intent(in),optional::arrn(:)
logical(4),intent(in),optional::symmetrize
end
end
