﻿!mod$ v1 sum:b58ea92a6d17cf70
module w90_sitesym
use w90_constants,only:dp
use w90_constants,only:cmplx_1
use w90_constants,only:cmplx_0
use w90_io,only:io_error
use w90_io,only:stdout
integer(4),save::nkptirr
integer(4),save::nsymmetry
integer(4),allocatable,save::kptsym(:,:)
integer(4),allocatable,save::ir2ik(:)
integer(4),allocatable,save::ik2ir(:)
complex(8),allocatable,save::d_matrix_band(:,:,:,:)
complex(8),allocatable,save::d_matrix_wann(:,:,:,:)
private::symmetrize_ukirr
private::orthogonalize_u
contains
subroutine sitesym_slim_d_matrix_band(lwindow_in)
use w90_parameters,only:num_bands
use w90_parameters,only:num_kpts
logical(4),intent(in),optional::lwindow_in(1_8:int(num_bands,kind=8),1_8:int(num_kpts,kind=8))
end
subroutine sitesym_replace_d_matrix_band()
end
subroutine sitesym_symmetrize_u_matrix(ndim,umat,lwindow_in)
use w90_parameters,only:num_wann
use w90_parameters,only:num_kpts
use w90_parameters,only:num_bands
integer(4),intent(in)::ndim
complex(8),intent(inout)::umat(1_8:int(ndim,kind=8),1_8:int(num_wann,kind=8),1_8:int(num_kpts,kind=8))
logical(4),intent(in),optional::lwindow_in(1_8:int(num_bands,kind=8),1_8:int(num_kpts,kind=8))
end
subroutine sitesym_symmetrize_gradient(imode,grad)
use w90_parameters,only:num_wann
use w90_parameters,only:num_kpts
integer(4),intent(in)::imode
complex(8),intent(inout)::grad(1_8:int(num_wann,kind=8),1_8:int(num_wann,kind=8),1_8:int(num_kpts,kind=8))
end
subroutine sitesym_symmetrize_rotation(urot)
use w90_parameters,only:num_wann
use w90_parameters,only:num_kpts
complex(8),intent(inout)::urot(1_8:int(num_wann,kind=8),1_8:int(num_wann,kind=8),1_8:int(num_kpts,kind=8))
end
subroutine sitesym_symmetrize_zmatrix(czmat,lwindow_in)
use w90_parameters,only:num_bands
use w90_parameters,only:num_kpts
complex(8),intent(inout)::czmat(1_8:int(num_bands,kind=8),1_8:int(num_bands,kind=8),1_8:int(num_kpts,kind=8))
logical(4),intent(in)::lwindow_in(1_8:int(num_bands,kind=8),1_8:int(num_kpts,kind=8))
end
subroutine symmetrize_ukirr(ir,ndim,umat,n)
use w90_parameters,only:num_wann
integer(4),intent(in)::ir
integer(4),intent(in)::ndim
complex(8),intent(inout)::umat(1_8:int(ndim,kind=8),1_8:int(num_wann,kind=8))
integer(4),intent(in),optional::n
end
subroutine orthogonalize_u(ndim,m,u,n)
integer(4),intent(in)::ndim
integer(4),intent(in)::m
complex(8),intent(inout)::u(1_8:int(ndim,kind=8),1_8:int(m,kind=8))
integer(4),intent(in)::n
end
subroutine sitesym_dis_extract_symmetry(ik,n,zmat,lambda,umat)
use w90_parameters,only:num_bands
use w90_parameters,only:num_wann
integer(4),intent(in)::ik
integer(4),intent(in)::n
complex(8),intent(in)::zmat(1_8:int(num_bands,kind=8),1_8:int(num_bands,kind=8))
complex(8),intent(out)::lambda(1_8:int(num_wann,kind=8),1_8:int(num_wann,kind=8))
complex(8),intent(inout)::umat(1_8:int(num_bands,kind=8),1_8:int(num_wann,kind=8))
end
subroutine sitesym_read()
end
subroutine sitesym_dealloc()
end
end
